--THIS ADD-ON IS A MODIFICATION OF THE GAME'S POSITIONING OF THE ContextActionBar ADD-ON--
Global("AM", userMods.GetGlobalConfigSection("ActionsM"))

Global("Scale", 1 )			 
Global("ShortcutColor", "White" )
Global("Size", 46)
Global("NotCastable", "Grey")										  
Global("EffectColor", "White")
Global("CooldownColor", "Red")
Global("CountdownScale", 1 )
Global("StackColor", "Yellow" )
Global("StackScale", 1 )
Global("ABBack", false )
Global("BottomBar", false )

--ADDON GLOBALS
Global("PanelConfig", {})
Global("PanelConfigDesc", mainForm:GetChildChecked("PanelConfig", false):GetWidgetDesc())
Global("Spell", {})
Global("NewCooldown", {})
Global("CooldownDesc", mainForm:GetChildChecked("NewCooldown", false):GetWidgetDesc())

Global("TextColor", {
	["Gold"] = "LogColorGold",
	["Blue"] = "LogColorBlue",
	["White"] = "LogColorWhite",
	["Grey"] = "LogColorBlack",
	["Black"] = "LogColorBlack",
	["Yellow"] = "LogColorYellow",
	["Cian"] = "LogColorCian",
	["Red"] = "LogColorRed",
	["Magenta"] = "LogColorMagenta",
	["Violet"] = "LogColorViolet",
	["Green"] = "LogColorGreen",
	["LightGreen"] = "LogColorLightGreen",
	["Brown"] = "LogColorBrown",
	["Orange"] = "LogColorOrange",
	["LightRed"] = "LogColorLightRed",
})

Global("BackgroundColor", {
	["Gold"] = {r = .5; g = .5; b = 0; a = 1},
	["Blue"] = {r = 0; g = 0; b = 1; a = 1},
	["White"] = {r = 1; g = 1; b = 1; a = 1},
	["Grey"] = {r = .5; g = .5; b = .5; a = 1},
	["Black"] = {r = 0; g = 0; b = 0; a = 1},
	["Yellow"] = {r = 1; g = 1; b = 0; a = 1},
	["Cian"] = {r = 0; g = 1; b = 1; a = 1},
	["Red"] = {r = 1; g = 0; b = 0; a = 1},
	["Magenta"] = {r = 1; g = 0; b = 1; a = 1},
	["Violet"] = {r = .5; g = 0; b = 1; a = 1},
	["Green"] = {r = 0; g = .5; b = 0; a = 1},
	["LightGreen"] = {r = 0; g = 1; b = 0; a = 1},
	["Brown"] = {r = .5; g = .25; b = 0; a = 1},
	["Orange"] = {r = 1; g = .5; b = 0; a = 1},
	["LightRed"] = {r = 1; g = .5; b = .5; a = 1},
	["Cus1"] = {r = 1; g = 1; b = 1; a = 1},
	["Cus2"] = {r = 1; g = 1; b = 1; a = 1},
	["Cus3"] = {r = 1; g = 1; b = 1; a = 1},
	["Cus4"] = {r = 1; g = 1; b = 1; a = 1},
	["Cus5"] = {r = 1; g = 1; b = 1; a = 1},
})

Global("absorbedC", {})

Global("Popup", mainForm:GetChildChecked("Popup", false))
Global("ColorOptions", nil)
Global("PopupText", {})
Global("PopupBtn", {})
Global("ColorBtn", {})
Global("ColorBtnDesc", nil)
Global("SliderPanel", mainForm:GetChildChecked("SlidersPanel", false))
Global("SliderP", {})
Global("Slider", {})
Global("CusType", "none")

Global("Sender", nil)
Global("ABReloaded", nil)
Global("EditLine", mainForm:GetChildChecked("EditLine", false))
Global("EditType", nil )
Global("FirstModify", nil)	

-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
function DNDControl( params )
	if userMods.FromWString( params.text ) == "/abdnd" then --TURN ON/OFF DND
		for i, v in pairs( PanelConfig ) do
			if Spell[i]:IsVisible() then
				PanelConfig[i]:Show(not PanelConfig[i]:IsVisible())
			end
		end
	elseif userMods.FromWString( params.text ) == "/abdndreset" then --RESET DND AND RESTART ADD-ON
		userMods.SetGlobalConfigSection("ActionsMod", {})
	elseif userMods.FromWString( params.text ) == "/ab" then
		WritePopup()
		Popup:Show(not Popup:IsVisible())
		ColorOptions:Show(false)
		EditLine:Show(false)
		for i = 0, 3 do 
			SliderP[i]:Show(false)
		end
	elseif common.IsSubstring(params.text, userMods.ToWString("/absize")) then
		local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 9)))
		if number ~= nil then
			AM["Si"] = number
		end
	elseif common.IsSubstring(params.text, userMods.ToWString("/abscale")) then
		local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 10)))
		if number ~= nil then
			AM["Sc"] = number / 10
		end
	elseif common.IsSubstring(params.text, userMods.ToWString("/abcdscale")) then
		local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 12)))
		if number ~= nil then
			AM["CDC"] = number / 10
		end
	elseif common.IsSubstring(params.text, userMods.ToWString("/abstscale")) then
		local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 12)))
		if number ~= nil then
			AM["SS"] = number / 10
		end
	elseif common.IsSubstring(params.text, userMods.ToWString("/abhide")) then
		local number = common.GetIntFromWString(userMods.ToWString(string.sub(userMods.FromWString(params.text), 9)))
		if Spell[number] then
			Spell[number]:Show(not Spell[number]:IsVisible())
		end
	elseif userMods.FromWString( params.text ) == "/abcusset" then
		local red = Slider[0]:GetPos()
		local green = Slider[1]:GetPos()
		local blue = Slider[2]:GetPos()
		local alpha = Slider[3]:GetPos()
		local color = SliderP[3]:GetBackgroundColor()
		color.r = red / 255
		color.b = blue / 255
		color.g = green / 255
		color.a = alpha / 255
		for i = 0, 3 do SliderP[i]:SetBackgroundColor(color) end
		AM[CusType] = color
		BackgroundColor[CusType] = color
		
	end
	userMods.SetGlobalConfigSection("ActionsM", AM)
	WritePopup()
	Change()
end

function GetTableSize( t ) --TAKEN FROM SAMPLEADDONBASE
	if not t then
		return 0
	end
	local count = 0
	for k, v in pairs( t ) do
		count = count + 1
	end
	return count
end

function WritePopup()
	PopupBtn[0]:SetVal("name", userMods.ToWString("Size: "..AM["Si"]) )
	PopupBtn[1]:SetVal("name", userMods.ToWString("Scale: "..AM["Sc"]) )
	PopupBtn[2]:SetVal("name", userMods.ToWString("CDScale: "..AM["CDC"]) )
	PopupBtn[3]:SetVal("name", userMods.ToWString("StackScale: "..AM["SS"]) )
	PopupBtn[4]:SetVal("name", userMods.ToWString("NotCastable"))
	for i = 0, 4 do
		PopupBtn[i]:SetBackgroundColor( BackgroundColor.Black )
	end
	PopupBtn[4]:SetBackgroundColor( BackgroundColor[AM["Fr"]] )
	PopupBtn[5]:SetVal("name", userMods.ToWString("EffectColor"))
	PopupBtn[5]:SetBackgroundColor( BackgroundColor[AM["Ef"]] )
	PopupBtn[6]:SetVal("name", userMods.ToWString("CDColor"))
	PopupBtn[6]:SetBackgroundColor( BackgroundColor[AM["CD"]] )
	PopupBtn[7]:SetVal("name", userMods.ToWString("StackColor"))
	PopupBtn[7]:SetBackgroundColor( BackgroundColor[AM["SC"]] )
	PopupBtn[8]:SetVal("name", userMods.ToWString("ShortcutColor"))
	PopupBtn[8]:SetBackgroundColor( BackgroundColor[AM["Sh"]] )
	PopupBtn[9]:SetVal("name", userMods.ToWString("ABar "..tostring(AM["ABB"])))
	PopupBtn[9]:SetBackgroundColor( BackgroundColor.Black )
	PopupBtn[10]:SetVal("name", userMods.ToWString("BBar "..tostring(AM["BB"])))
	PopupBtn[10]:SetBackgroundColor( BackgroundColor.Black )
	for i = 1, 5 do
		PopupBtn[i + 10]:SetVal("name", userMods.ToWString("Custom".." "..i))
		PopupBtn[i + 10]:SetBackgroundColor( BackgroundColor["Cus"..i])
	end
	PopupBtn[16]:SetVal("name", userMods.ToWString("CusSet "..CusType))
	PopupBtn[16]:SetBackgroundColor( BackgroundColor.Black )
end

function Change()
	local PositionY = widgetsSystem:GetPosConverterParams().fullVirtualSizeY - AM["Si"] --SCREEN SCALING
	local PositionX = widgetsSystem:GetPosConverterParams().fullVirtualSizeX - 1000
	local X = 0
	local Y = 0
	for i = 1, 49 do --MODIFY SLOTS
		if Spell[i] then
			local P = Spell[i]:GetPlacementPlain()
			P.alignX = WIDGET_ALIGN_LOW
			P.alignY = WIDGET_ALIGN_LOW
			P.posX = math.ceil(AM["Si"] * (i - (1 * X))) + PositionX
			P.sizeX = AM["Si"]
			P.sizeY = AM["Si"]
			P.posY = PositionY
			if Y > 0 then
				P.posY = (-AM["Si"] * Y) + PositionY
			end
			if i == 12 or i == 24 or i == 36 or i == 48 then
				X = X + 12
				Y = Y + 1
			end
			Spell[i]:SetPlacementPlain(P)
			local Shortcut = Spell[i]:GetChildChecked("Shortcut", false)
			Shortcut:SetTextScale(AM["Sc"])
			Shortcut:SetClassVal("class", TextColor[AM["Sh"]])
			local Frame = Spell[i]:GetChildChecked("Frame", false)
			Frame:SetBackgroundColor(BackgroundColor[AM["Fr"]])
			local FP = Frame:GetPlacementPlain()
			FP.alignX = WIDGET_ALIGN_BOTH
			FP.alignY = WIDGET_ALIGN_BOTH
			Frame:SetPlacementPlain(FP)
			local Effect = Frame:GetChildChecked("Prepared", false):GetChildChecked("Effect", false)
			Effect:SetBackgroundColor(BackgroundColor[AM["Ef"]])
			local CD = Frame:GetChildChecked("Cooldown", false):GetChildChecked("Gauge", false)
			CD:Show(false)
			local color = BackgroundColor[AM["CD"]]
			color.a = .5
			NewCooldown[i]:SetBackgroundColor(color)
			NewCooldown[i]:SetPriority(Spell[1]:GetPriority())
			local CDC = Frame:GetChildChecked("Countdown", false)
			CDC:SetTextScale(AM["CDC"])
			local SC = Frame:GetChildChecked("Count", false)
			SC:SetTextScale(AM["SS"])
			SC:SetClassVal("class", TextColor[AM["SC"]])
			DnD:Init(950 + i, PanelConfig[i], Spell[i], true) --DND SLOTS
		end
	end
	if AM["ABB"] == true and absorbedC[0] then
		absorbedC[0]:Show(true)
	elseif absorbedC[0] then
		absorbedC[0]:Show(false)
	end
	if AM["BB"] == true and absorbedC[1] then
		absorbedC[1]:Show(true)
	elseif absorbedC[1] then
		absorbedC[1]:Show(false)
	end
end

function Modify()
	if avatar.IsExist() then
		local children = stateMainForm: GetNamedChildren () --START COLLECTION OF ACTION SLOTS
		local children3
		local ActionBar
		for i = 0, GetTableSize (children) - 1 do
			local wtChild = children [i]
			local name = wtChild:GetName()
			local children2 = wtChild: GetNamedChildren ()
			for j = 0, GetTableSize (children2) - 1 do
				wtChild = children2 [j]
				local name2 = wtChild:GetName()
				if name2 == "AddLeft" then
					ActionBar = wtChild
					break
				end
			end
		end
		
		children3 = ActionBar:GetParent():GetNamedChildren()
		for k = 0, GetTableSize(children3) - 1 do
			local wtChild = children3[k]
			local name2 = wtChild:GetName()
			local children4 = wtChild:GetNamedChildren ()
			for x = 0, GetTableSize(children4) - 1 do
				local wtChild = children4[x]
				local name3 = wtChild:GetName()
				for z = 1, 48 do
					if z >= 1 and z < 10 then
						if name3 == "Action".."0"..z then --COLLECT 00 to 09
							PanelConfig[z] = mainForm:CreateWidgetByDesc(PanelConfigDesc)
							NewCooldown[z] = mainForm:CreateWidgetByDesc(CooldownDesc)
							Spell[z] = wtChild
							wtChild:AddChild(PanelConfig[z])
							wtChild:GetChildChecked("Frame", false):AddChild(NewCooldown[z])
						end
					end
					if name3 == "Action"..z then --COLLECT 10-48
						PanelConfig[z] = mainForm:CreateWidgetByDesc(PanelConfigDesc)
						NewCooldown[z] = mainForm:CreateWidgetByDesc(CooldownDesc)
						Spell[z] = wtChild
						wtChild:AddChild(PanelConfig[z])
						wtChild:GetChildChecked("Frame", false):AddChild(NewCooldown[z])
					end
				end
			end
		end
		
		for i = 0, GetTableSize(children3) - 1 do --HIDE ACTION BARS ASIDE FROM LEFT
			local wtChild = children3[i]
			local name = wtChild:GetName()
			if name == "AddLeft" then
				wtChild:GetChildChecked("Back", false):SetBackgroundColor({r=0;g=0;b=0;a=0}) --HIDE LEFT'S BACK PANEL (over-expanded)
				for j = 1, 49 do
					if Spell[j] then
						wtChild:AddChild(Spell[j]) --ADD ALL ACTION SLOTS TO LEFT
					end
				end
				local P = mainForm:GetPlacementPlain()
				P.alignX = WIDGET_ALIGN_BOTH --EXPAND LEFT TO FIT SCREEN
				P.alignY = WIDGET_ALIGN_BOTH
				P.posX = 0
				P.posY = 0
				wtChild:GetParent():SetPlacementPlain(P)
				wtChild:SetPlacementPlain(P)
				wtChild:GetParent():SetPriority(5000)
				wtChild:Show(true)
			elseif name == "ActionBar" then --ABSORB ACTION BAR
				ABReloaded = wtChild
				local Desc = wtChild:GetWidgetDesc()
				absorbedC[0] = mainForm:CreateWidgetByDesc(Desc)
				mainForm:AddChild(absorbedC[0])
				wtChild:Show(false)
				local aChildren = absorbedC[0]:GetNamedChildren()
				for i, v in pairs( aChildren ) do
					v:DestroyWidget()
				end
			elseif name == "Bottom" then --ABSORB BOTTOM LINE
				local Desc = wtChild:GetWidgetDesc()
				absorbedC[1] = mainForm:CreateWidgetByDesc(Desc)
				mainForm:AddChild(absorbedC[1])
				wtChild:Show(false)
			else
				wtChild:Show(false)
			end
		end
		
		Change()
		collectgarbage()
		if not FirstModify then
			common.UnRegisterEventHandler( Modify, "EVENT_SECOND_TIMER" )
			FirstModify = 1
		end
	end
end

function Resize(params)
	Change()
end

function PopupCP(Type)
	local num = 0
	if Type then
		for i, v in pairs( BackgroundColor ) do
			if ColorBtn[i] then
				ColorBtn[i]:Show(false)
			end
		end
	else Type = BackgroundColor end
	for i, v in pairs( Type ) do
		if ColorBtn[i] == nil then
			ColorBtn[i] = mainForm:CreateWidgetByDesc(ColorBtnDesc)
			ColorOptions:AddChild(ColorBtn[i])
		end
		local P = ColorBtn[i]:GetPlacementPlain()
		P.alignX = WIDGET_ALIGN_LOW
		P.posX = 20 * num
		P.sizeX = 20
		P.sizeY = 20
		ColorBtn[i]:SetPlacementPlain(P)
		num = num + 1
		ColorBtn[i]:SetBackgroundColor(BackgroundColor[i])
		ColorBtn[i]:SetName("ColorBtn"..i)
		ColorBtn[i]:Show(true)
	end
	local P = ColorOptions:GetPlacementPlain()
	P.sizeX = num * 20
	P.sizeY = 20
	ColorOptions:SetPlacementPlain(P)
end

function PopupBtns( reaction )
	local owner = reaction.sender
	if owner == "Fr" then
		PopupCP()
		Sender = "Fr"
		ColorOptions:Show(true)
	elseif owner == "Ef" then
		PopupCP()
		Sender = "Ef"
		ColorOptions:Show(true)
	elseif owner == "CD" then
		PopupCP()
		Sender = "CD"
		ColorOptions:Show(true)
	elseif owner == "SC" then
		PopupCP(TextColor)
		Sender = "SC"
		ColorOptions:Show(true)
	elseif owner == "Sh" then
		PopupCP(TextColor)
		Sender = "Sh"
		ColorOptions:Show(true)
	elseif owner == "ABB" then
		AM["ABB"] = not AM["ABB"]
		Change()
		WritePopup()
	elseif owner == "BB" then
		AM["BB"] = not AM["BB"]
		Change()
		WritePopup()
	elseif owner == "Si" then
		EditType = owner
		EditLine:Show(true)
		EditLine:SetFocus(true)
	elseif owner == "Sc" then
		EditType = owner
		EditLine:Show(true)
		EditLine:SetFocus(true)
	elseif owner == "CDC" then
		EditType = owner
		EditLine:Show(true)
		EditLine:SetFocus(true)
	elseif owner == "SS" then
		EditType = owner
		EditLine:Show(true)
		EditLine:SetFocus(true)
	elseif owner == "Set" then
		local red = Slider[0]:GetPos()
		local green = Slider[1]:GetPos()
		local blue = Slider[2]:GetPos()
		local alpha = Slider[3]:GetPos()
		local color = SliderP[3]:GetBackgroundColor()
		color.r = red / 255
		color.b = blue / 255
		color.g = green / 255
		color.a = alpha / 255
		for i = 0, 3 do SliderP[i]:SetBackgroundColor(color) end
		AM[CusType] = color
		BackgroundColor[CusType] = color
		WritePopup()
	elseif common.IsSubstring(userMods.ToWString(owner), userMods.ToWString("Cus")) and not common.IsSubstring(userMods.ToWString(owner), userMods.ToWString("ColorBtn")) then
		local number = string.sub(owner, 4)
		Slider[0]:SetPos(math.ceil(BackgroundColor["Cus"..number].r * 255))
		Slider[1]:SetPos(math.ceil(BackgroundColor["Cus"..number].g * 255))
		Slider[2]:SetPos(math.ceil(BackgroundColor["Cus"..number].b * 255))
		Slider[3]:SetPos(math.ceil(BackgroundColor["Cus"..number].a * 255))
		for i = 0, 3 do 
			SliderP[i]:SetBackgroundColor(AM["Cus"..number])
			SliderP[i]:Show(not SliderP[i]:IsVisible())
		end
		CusType = "Cus"..number
		WritePopup()
	elseif common.IsSubstring(userMods.ToWString(owner), userMods.ToWString("ColorBtn")) then
		local color = string.sub(owner, 9)
		AM[Sender] = color
		ColorOptions:Show(false)
		WritePopup()
		Change()
	end
	userMods.SetGlobalConfigSection("ActionsM", AM)
end

function ContextActionBarReloaded()
	if ABReloaded then
		if ABReloaded:IsVisible() == true then
			Modify()
		end
	end
end

function SliderChange( reaction )
	local red = Slider[0]:GetPos()
	local green = Slider[1]:GetPos()
	local blue = Slider[2]:GetPos()
	local alpha = Slider[3]:GetPos()
	local color = SliderP[3]:GetBackgroundColor()
	color.r = red / 256
	color.b = blue / 256
	color.g = green / 256
	color.a = alpha / 256
	for i = 0, 3 do SliderP[i]:SetBackgroundColor(color) end
end

function Coolingdown( params )
	if params.effect == EFFECT_TYPE_COOLDOWN_STARTED then
		if params.remaining >= params.duration - 100 and NewCooldown[params.index+1] then
			local P = NewCooldown[params.index+1]:GetPlacementPlain()
			P.alignY = WIDGET_ALIGN_LOW
			P.alignX = WIDGET_ALIGN_LOW
			P.posX = 1
			P.posY = 1
			P.sizeX = AM["Si"] - 2
			P.sizeY = AM["Si"] - 1
			NewCooldown[params.index+1]:SetPlacementPlain(P)
			NewCooldown[params.index+1]:Show(true)
			
			local fromY = NewCooldown[params.index+1]:GetPlacementPlain()
			local toY = NewCooldown[params.index+1]:GetPlacementPlain()
			toY.sizeY = 1
			
			if params.duration > 0 then
				NewCooldown[params.index+1]:PlayResizeEffect( fromY, toY, params.duration, EA_MONOTONOUS_INCREASE )
			end
		end
	elseif params.effect == EFFECT_TYPE_COOLDOWN_FINISHED and NewCooldown[params.index+1] then
		NewCooldown[params.index+1]:FinishResizeEffect()
		NewCooldown[params.index+1]:Show(false)
	end
end

--ADDON MANAGER COOPERATION
function OnEventAMMemUsageRequest() --MEMORY
	userMods.SendEvent( "U_EVENT_ADDON_MEM_USAGE_RESPONSE", { sender = common.GetAddonName(), memUsage = gcinfo() } )
end

function EditLineData()
	local text = EditLine:GetText()
	if EditType ~= "Si" then
		local number = common.GetIntFromWString(text)
		if number then
			AM[EditType] = number / 10
		end
	else
		local number = common.GetIntFromWString(text)
		if number then
			AM[EditType] = number
		end
	end
	WritePopup()
	Change()
	userMods.SetGlobalConfigSection("ActionsM", AM)
	EditLine:Show(false)
end

function EditLineEscape()
	EditLine:Show(false)
end

--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	common.RegisterEventHandler( DNDControl, "EVENT_UNKNOWN_SLASH_COMMAND" )	
	common.RegisterEventHandler( Modify, "EVENT_SECOND_TIMER" )
	common.RegisterEventHandler( Resize, "EVENT_UPDATE_SHRINK_RATIO" )
	-- ADDON MANAGER EVENTS (MEMORY)
	common.RegisterEventHandler( OnEventAMMemUsageRequest, "U_EVENT_ADDON_MEM_USAGE_REQUEST" )
	
	common.RegisterEventHandler( ContextActionBarReloaded, "EVENT_SECOND_TIMER" )
	common.RegisterEventHandler( Coolingdown, "EVENT_ACTION_PANEL_ELEMENT_EFFECT" )
	
	common.RegisterReactionHandler( PopupBtns, "PopupBtn" )
	common.RegisterReactionHandler( SliderChange, "SliderChange" )
	common.RegisterReactionHandler( EditLineData, "EditLineEnter" )
	common.RegisterReactionHandler( EditLineEscape, "EditLineEscape" )
	
	if not AM or AM["BB"] == nil then
		AM = {}
		AM["Si"] = Size
		AM["Sc"] = Scale
		AM["Sh"] = ShortcutColor
		AM["Fr"] = NotCastable
		AM["Ef"] = EffectColor
		AM["CD"] = CooldownColor
		AM["CDC"] = CountdownScale
		AM["SS"] = StackScale
		AM["SC"] = StackColor
		AM["ABB"] = ABBack
		AM["BB"] = BottomBar
	end
	for i = 1, 5 do
		if AM["Cus"..i] == nil then
			AM["Cus"..i] = BackgroundColor["Cus"..i]
			userMods.SetGlobalConfigSection("ActionsM", AM)
		else
			BackgroundColor["Cus"..i] = AM["Cus"..i]
		end
	end
	
	Popup:SetBackgroundColor( BackgroundColor.Black )
	local PopupDesc = Popup:GetWidgetDesc()
	ColorOptions = mainForm:CreateWidgetByDesc( PopupDesc )
	ColorOptions:SetBackgroundColor( BackgroundColor.Black )
	
	local P = Popup:GetPlacementPlain()
	P.posX = P.posX + P.sizeX
	ColorOptions:SetPlacementPlain(P)
	
	local T = EditLine:GetPlacementPlain()
	T.posX = P.posX
	T.posY = P.posY - 20
	EditLine:SetPlacementPlain(T)
	
	local PopupTextDesc = Popup:GetChildChecked("PopupText", false):GetWidgetDesc()
	local PopupBtnDesc = Popup:GetChildChecked("PopupBtn", false):GetWidgetDesc()
	ColorBtnDesc = ColorOptions:GetChildChecked("PopupBtn", false):GetWidgetDesc()
	
	PopupText[0] = mainForm:CreateWidgetByDesc( PopupTextDesc )
	Popup:AddChild( PopupText[0] )
	PopupText[0]:Show(true)
	PopupText[0]:SetClassVal("class", "Size14")
	PopupText[0]:SetVal("name", userMods.ToWString("ActionsMod"))
	
	for i = 0, 16 do
		PopupBtn[i] = mainForm:CreateWidgetByDesc( PopupBtnDesc )
		Popup:AddChild( PopupBtn[i] )
		PopupBtn[i]:Show(true)
		local P = PopupBtn[0]:GetPlacementPlain()
		P.posY = 20 * i + 20
		PopupBtn[i]:SetPlacementPlain(P)
	end

	PopupBtn[0]:SetName("Si")
	PopupBtn[1]:SetName("Sc")
	PopupBtn[2]:SetName("CDC")
	PopupBtn[3]:SetName("SS")
	PopupBtn[4]:SetName("Fr")
	PopupBtn[5]:SetName("Ef")
	PopupBtn[6]:SetName("CD")
	PopupBtn[7]:SetName("SC")
	PopupBtn[8]:SetName("Sh")
	PopupBtn[9]:SetName("ABB")
	PopupBtn[10]:SetName("BB")
	PopupBtn[11]:SetName("Cus1")
	PopupBtn[12]:SetName("Cus2")
	PopupBtn[13]:SetName("Cus3")
	PopupBtn[14]:SetName("Cus4")
	PopupBtn[15]:SetName("Cus5")
	PopupBtn[16]:SetName("Set")
	
	local SliderDesc = SliderPanel:GetWidgetDesc()
	for i = 0, 3 do
		SliderP[i] = mainForm:CreateWidgetByDesc(SliderDesc)
		local P = SliderP[i]:GetPlacementPlain()
		P.posX = 32 * i + P.posX
		SliderP[i]:SetPlacementPlain(P)
		Slider[i] = SliderP[i]:GetChildChecked("ColorSlider", false)
	end
	SliderPanel:DestroyWidget()
	
	EditLine:SetBackgroundColor(BackgroundColor["Black"])
	EditLine:Show(false)
	EditLine:SetGlobalClasses( {[1] = "tip_blue", [2] = "Size14",})
end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------